@echo off

set DAYS=3650
set name=%1
set opsc_cert=%2

set shouldrun=false
if NOT EXIST %NAME%KeyStore.pem set shouldrun=true
if NOT EXIST %NAME%.Keystore set shouldrun=true
if "%shouldrun%"=="false" goto finally

if [%OPENSSL_EXE%]==[] (
    set OPENSSL_EXE=c:\OpenSSL-Win32\bin\openssl
)

set KEYTOOL="%JAVA_HOME%"\bin\keytool.exe

%KEYTOOL% -genkey -dname "cn=Unknown, ou=Unknown, o=Unknown, c=Unknown" ^
 -alias agent_key -keypass opscenter -keystore "%name%KeyStore" ^
 -storepass opscenter -validity %DAYS%
if NOT "%ERRORLEVEL%"=="0" exit /b %ERRORLEVEL%

%KEYTOOL% -importkeystore -srckeystore "%name%KeyStore" -destkeystore "%name%KeyStore.p12" ^
 -srcstoretype JKS -deststoretype PKCS12 -srcstorepass opscenter -deststorepass opscenter ^
 -srcalias agent_key -destalias agent_key -srckeypass opscenter -destkeypass opscenter -noprompt
if NOT "%ERRORLEVEL%"=="0" exit /b %ERRORLEVEL%

%OPENSSL_EXE% pkcs12 -in "%name%KeyStore.p12" -out "%name%KeyStore.pem" ^
 -passin "pass:opscenter" -passout "pass:opscenter"
%KEYTOOL% -import -alias opscenter_cert -file "%opsc_cert%" ^
 -keystore "%name%KeyStore" --storepass opscenter --noprompt
if NOT "%ERRORLEVEL%"=="0" exit /b %ERRORLEVEL%
goto finally

:err
echo The JAVA_HOME environment variable must be set.
exit /b 1

:finally

ENDLOCAL
